MODULE Spez;

IMPORT B := Spielbrett, G := Grund;

PROCEDURE Addieren*(mo: INTEGER);
VAR zeile: INTEGER;
BEGIN
    FOR zeile := 0 TO 10 DO
        B.brett[2, zeile].gesamt := B.brett[0, zeile].gesamt + B.brett[1, zeile].gesamt
    END;
    B.FeldLoeschen(0,mo);  B.FeldLoeschen(1,mo);
    B.AllesZeichnen(FALSE,mo);
END Addieren;

PROCEDURE Kopieren23*(wert: LONGINT; mo: INTEGER);
VAR zeile, i: INTEGER;
BEGIN
    IF ~B.Leer(0) & ~B.Leer(1) & (B.Maximum(0) + B.Maximum(1) <= 10) THEN
        zeile := G.Zeile(wert);
        IF (zeile IN {0, 2, 4, 6, 8, 10}) & (B.brett[0, zeile].gesamt >= 1) THEN
            B.brett[0, zeile].hohl := 1;
            B.AllesZeichnen(TRUE,mo);
            FOR i := 0 TO B.Maximum(1) DO
                B.brett[1, i].hohl := B.brett[1, i].gesamt
            END;
            B.AllesZeichnen(TRUE,mo);
            FOR i := 0 TO B.Maximum(1) DO
                B.brett[2, i+zeile].gesamt := B.brett[2, i+zeile].gesamt + B.brett[1, i].hohl;
                B.brett[2, i+zeile].hohl := B.brett[1, i].hohl
            END;
            B.AllesZeichnen(TRUE,mo);
            FOR i := 0 TO 10 DO
                B.brett[1, i].hohl := 0;
                B.brett[2, i].hohl := 0
            END;
            B.brett[0, zeile].hohl := 0;
            DEC(B.brett[0, zeile].gesamt);
            B.AllesZeichnen(FALSE,mo)
        END    
    END
END Kopieren23;

PROCEDURE Subtrahieren1*(mo: INTEGER);
VAR zeile: INTEGER;
BEGIN
    FOR zeile := 0 TO 10 DO
        IF B.brett[0, zeile].gesamt >= B.brett[1, zeile].gesamt 
        THEN B.brett[0, zeile].hohl := B.brett[1, zeile].gesamt;
                    B.brett[1, zeile].hohl := B.brett[1, zeile].gesamt
        ELSE B.brett[0, zeile].hohl := B.brett[0, zeile].gesamt;
                    B.brett[1, zeile].hohl := B.brett[0,zeile].gesamt
        END
    END;    
    B.AllesZeichnen(TRUE,mo);
    FOR zeile := 0 TO 10 DO
        B.brett[0, zeile].gesamt := B.brett[0, zeile].gesamt - B.brett[0, zeile].hohl;
        B.brett[0, zeile].hohl := 0;
        B.brett[1, zeile].gesamt := B.brett[1, zeile].gesamt - B.brett[1, zeile].hohl;
        B.brett[1, zeile].hohl := 0
    END;
    B.AllesZeichnen(FALSE,mo)
END Subtrahieren1;

PROCEDURE Subtrahieren2*(wert: LONGINT; mo: INTEGER);
VAR zeile: INTEGER;
BEGIN
    zeile := G.Zeile(wert);
    IF B.brett[0, zeile].gesamt >= B.brett[1, zeile].gesamt 
    THEN B.brett[0, zeile].hohl := B.brett[1, zeile].gesamt;
                B.brett[1, zeile].hohl := B.brett[1, zeile].gesamt
    ELSE B.brett[0, zeile].hohl := B.brett[0, zeile].gesamt;
                B.brett[1, zeile].hohl := B.brett[0, zeile].gesamt
    END;
    B.AllesZeichnen(TRUE,mo);
    B.brett[0, zeile].gesamt := B.brett[0, zeile].gesamt - B.brett[0, zeile].hohl;
    B.brett[0, zeile].hohl := 0;
    B.brett[1, zeile].gesamt := B.brett[1, zeile].gesamt - B.brett[1, zeile].hohl;
    B.brett[1, zeile].hohl := 0;
    B.AllesZeichnen(FALSE,mo)
END Subtrahieren2;

PROCEDURE Verschieben13*(mo: INTEGER);
VAR zeile: INTEGER;
BEGIN
    IF (B.Leer(1))&(~B.Leer(0))THEN     (* Es gab rger mit der Maus! *)
        FOR zeile := 0 TO 10 DO
            B.brett[2, zeile].gesamt := B.brett[0, zeile].gesamt;
            B.brett[0, zeile].gesamt := 0;
        END;
        B.AllesZeichnen(FALSE,mo);
    END;
END Verschieben13;

PROCEDURE Wegnehmen*(differenz: INTEGER; mo: INTEGER);

VAR maximum, i: INTEGER;

    PROCEDURE Test(diff: INTEGER): BOOLEAN;
    VAR test    : BOOLEAN;
        max, k  : INTEGER;
    BEGIN
        max := B.Maximum(1);
        IF max # -1 THEN
            test := TRUE;
            FOR k := 0 TO max DO
                test := test & (B.brett[0, k+diff].gesamt >= B.brett[1, k].gesamt)
            END;
            RETURN test
        ELSE RETURN FALSE
        END
    END Test;

BEGIN
    differenz := 2 * differenz;
    maximum := B.Maximum(1);
    IF maximum+differenz <= 10 THEN
        IF Test(differenz) THEN
            FOR i := 0 TO maximum DO
                B.brett[1, i].hohl := B.brett[1, i].gesamt;
                B.brett[0, i+differenz].hohl := B.brett[1, i].gesamt
            END;
            B.AllesZeichnen(TRUE,mo);
            FOR i := 0 TO maximum DO
                B.brett[1, i].hohl := 0;
                B.brett[0, i+differenz].gesamt 
                    := B.brett[0, i+differenz].gesamt - B.brett[0, i+differenz].hohl;
                B.brett[0, i+differenz].hohl := 0
            END;
            INC(B.brett[2, differenz].gesamt);
            B.brett[2, differenz].hohl := 1;
            B.AllesZeichnen(TRUE,mo);
            B.brett[2, differenz].hohl := 0;
            B.AllesZeichnen(FALSE,mo)
        END
    END    
END Wegnehmen;
END Spez.
